<template lang="pug">
.card(:class="{ 'card_double': isItemDouble || alwaysDouble }")
  .card__age(v-if="!isItemDouble && !alwaysDouble") {{ age }}
  img.card__image(:src="item.photo_link")
  .card__text
    .card__text-wrapper
      .card__title {{ item.title }}
      .card__desc {{ item.description }}

      .card__seats(v-if="isItemDouble && type === 'event'")
        img.card__icon(src="@/assets/icon_baby.png")
        | до {{ item.number_of_seats }} детей
      .card__age-icon(v-if="isItemDouble && type === 'event'")
        img.card__icon(src="@/assets/icon_size.png")
        | {{ age }}
      .card__deviation-icon(v-if="isItemDouble && type === 'event'")
        img.card__icon(src="@/assets/icon_card.png")
        | {{ item.type_of_deviation_name }}

      .card__seats(v-if="isItemDouble && type === 'program'")
        img.card__icon(src="@/assets/icon_type_program.png")
        | {{ item.program_type_name }}
      .card__age-icon(v-if="isItemDouble && type === 'program'")
        img.card__icon(src="@/assets/icon_level.png")
        | {{ item.complexity_type_name }}
      .card__deviation-icon(v-if="isItemDouble && type === 'program'")
        img.card__icon(src="@/assets/icon_category_program.png")
        | {{ item.program_edu_area_name }}

    .card__footer
      .card__deviation(v-if="!isItemDouble") {{ item.type_of_deviation_name }}
      Button(
        type="secondary"
        size="mini"
        @click="more"
      )
        slot Подробнее
</template>

<script>
import Button from '@/components/parts/Button.vue'

export default {
  name: 'Card',
  components: {
    Button
  },
  props: {
    item: Object,
    number: Number,
    type: String,
    alwaysDouble: Boolean,
    numberDouble: Number
  },
  computed: {
    age() {
      if (!this.alwaysDouble) {
        const { min_age, max_age } = this.item
        return `${min_age} - ${max_age} лет`
      } else return ''
    },
    isItemDouble() {
      return (this.numberDouble !== -1) ? (this.number % this.numberDouble === 0) : false
    },
    authorized() {
      return this.$store.getters.authorized
    }
  },
  methods: {
    more() {
      if (!this.alwaysDouble) {
        const name = (this.type === 'event') ? 'EventView' : 'ProgramView'
        this.$router.push({ name, params: { id: this.item.id }})
      } else if (this.authorized)
        this.$router.push({ name: "Programs" })
      else
        this.$router.push({ name: "Registration" })
    }
  }
}
</script>

<style lang="stylus" scoped>
@import '~@/stylus/mixins.styl'

.card
  border-radius: 10px
  width: 270px
  display: flex
  flex-direction: column
  margin: 10px
  position: relative
  min-height: 390px
  transition: box-shadow 0.2s
  box-shadow: 2px 2px 5px 2px rgba(0,0,0,0.1)
  text-align: center
  &:hover
    box-shadow: 2px 2px 8px 2px rgba(0,0,0,0.2)
  &__image
    width: 100%
    border-radius: 10px 10px 0 0
    object-fit: cover
    height: 180px
  &__age
    position: absolute
    top: 0
    font-size: 0.8em
    padding: 2px 0
    text-align: center
    color lightColor
    left: 60px
    background: mainColor
    border-radius: 0 0 10px 10px
    width: 150px
  &__text
    height: 47%
    padding: 10px
    display: flex
    justify-content: space-between
    flex-direction: column
    flex-grow: 1
  &__title
    font-size: 1.4em
    font-weight: 700
    line-height: 1em
  &__desc
    margin: 15px 0
    font-size: 0.9em
  &__icon
    width: 30px
    margin-right: 10px
  &__seats, &__age-icon, &__deviation-icon
    display: flex
    margin-bottom: 10px
    font-weight: 700
    align-items: center
  &__deviation
    font-weight: 700
    text-decoration: underline
    font-size: 0.8em
    margin-bottom: 5px
  >>> .btn
    width: 100%

  &.card_double
    width: 560px
    text-align: left
    display: flex
    flex-direction: row
  &.card_double &__image
    width: 270px
    height: 100%
    border-radius: 10px 0 0 10px
  &.card_double &__text
    height: 93%
    width: 50%
    padding: 20px

</style>
